#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		sendPrivate(p, "---------Tk Bot---------");
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SysOp:
			{	// SysOp-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
				sendPrivate(p, "Bot Smod Commands: !tklimit <#> !tkbantime <#> !tktime <#> !requestertime <#>");
				sendPrivate(p, "Bot Smod Commands: !listtkers !deletetker <PlayerName> !killtkmods [Yes/No] !warn [On/Off]");
			}
		case OP_Moderator:
			{	// Moderator-level commands
				sendPrivate(p, "Bot Mod Commands: !tkstatus [On/Off]");
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
				if(Enabled)
				{sendPrivate(p, "Player Commands: !tker <PlayerName>");}
				else
				{sendPrivate(p, "Player Commands: Disabled");}
			}
		}
		sendPrivate(p, "------------------------");
		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if(c->checkParam("tklimit"))
			{
				sendPrivate(p,"Command !tklimit #: Sets the amount of team kills necessary for the bot to *kill a player");
			}
			else if(c->checkParam("tkbantime"))
			{
				sendPrivate(p,"Command !tkbantime #: Sets how long a player will be banned for if they team kill over the tklimit");
			}
			else if(c->checkParam("tktime"))
			{
				sendPrivate(p, "Command !tktime #: Sets the length of time that a player\'s team kills are recorded for. If the player gets the tklimit in this length of time, they are *kill(ed)");
			}
			else if(c->checkParam("requestertime"))
			{
				sendPrivate(p, "Command !requestertime #: Sets the length of time that a !tker requester has until he/she is allowed to use that command again. Bot-Mods will not be limited to how many !tker requests they issue");
			}
			else if(c->checkParam("listtkers"))
			{
				sendPrivate(p, "Command !listtkers: Will print out a list of all the team killers the bot is watching");
			}
			else if(c->checkParam("deletetker"))
			{
				sendPrivate(p, "Command !deletetker <PlayerName>: Deletes a player from the list of team killers the bot is watching");
			}
			else if(c->checkParam("killtkmods"))
			{
				sendPrivate(p, "Command !killtkmods [Yes/No]: Protects your staff from the bot\'s wrath if set to NO. Otherwise bot-op staff will be subject to the team killing limits if set to YES");
			}
			else if(c->checkParam("warn"))
			{
				sendPrivate(p, "Command !warn [On/Off]: Turns the team killing warning message On or Off");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if(c->checkParam("tkstatus"))
			{
				sendPrivate(p, "Command !tkstatus [On/Off]: Turns ON or OFF this bot\'s functions. Ex- !tkstatus on");
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if(c->checkParam("tker"))
			{
				sendPrivate(p, "Command !tker <PlayerName>: Reports team killers to the bot. If the team killer continues team killing, the bot will ban them for a short amount of time");
				if(p->access >= OP_Moderator)
				{
					sendPrivate(p, "--Op Level !tker Commands: The tker command will not have a time limit for you. Also, if someone is already being !tker watched by the bot, the bot will show you how many TKs they have had and how long until the bot stops watching them"); 
				}
			}
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if(c->check("tklimit"))
			{
				String TkLimit=c->final;
				String Message;

				if(!TkLimit.IsEmpty())
				{
					if(isNumeric(TkLimit.msg))
					{
						MaxTks= TkLimit.toInteger();
						Message= "TkLimit Change: Players who cause ";
						Message+=TkLimit;
						Message+= " team kills are *kill for ";
						Message+=BanTime;
						Message+=" minutes.";
					}
					else
					{
						Message= "You must specify a number! Format- !tklimit #";
					}
				}
				else
				{
					Message= "Current team kill limit is ";
					Message+= MaxTks;
					Message+= " team kills.";
				}
				sendPrivate(p,Message);
			}
			else if(c->check("tkbantime"))
			{
				String TkBanTime=c->final;
				String Message;

				if(!TkBanTime.IsEmpty())
				{
					if(isNumeric(TkBanTime.msg))
					{
						BanTime= TkBanTime.toInteger();
						Message= "The length of time for *kill has been changed to ";
						Message+=BanTime;
						Message+= " minutes.";
					}
					else
					{
						Message= "You must specify a number! Format- !tkbantime #";
					}
				}
				else
				{
					Message= "The length of time for *kill is ";
					Message+= BanTime;
					Message+= " minutes.";
				}
				sendPrivate(p,Message);
			}
			else if(c->check("tktime"))
			{
				String Time=c->final;
				String Message;

				if(!Time.IsEmpty())
				{
					if(isNumeric(Time.msg))
					{
						TkTime= Time.toInteger();
						Message= "TkTime Change: Players can\'t team kill ";
						Message+=MaxTks;
						Message+=" team mates in ";
						Message+=TkTime;
						Message+= " minutes.";
					}
					else
					{
						Message= "You must specify a number! Format- !tktime #";
					}
				}
				else
				{
					Message= "Players can\'t team kill ";
					Message+=MaxTks;
					Message+=" team mates in ";
					Message+=TkTime;
					Message+= " minutes.";
				}
				sendPrivate(p,Message);
			}
			else if(c->check("requestertime"))
			{
				String Time=c->final;
				String Message;

				if(!Time.IsEmpty())
				{
					if(isNumeric(Time.msg))
					{
						RequestTime= Time.toInteger();
						Message= "Requester Time Change: Players can\'t use !tker for ";
						Message+=RequestTime;
						Message+=" minutes after use";
					}
					else
					{
						Message= "You must specify a number! Format- !requestertime #";
					}
				}
				else
				{
					Message= "Players can\'t use !tker for ";
					Message+=RequestTime;
					Message+=" minutes after use";
				}
				sendPrivate(p,Message);
			}
			else if(c->check("listtkers"))
			{
				_listnode <TkStats> *tl= TkerList.head;
				String Message;
				String Info;
				String Lines= "--------------------|";

				sendPrivate(p,"|" +Lines+Lines+Lines);
				while(tl)
				{
					Info="|";
					Info+=tl->item->Name;
					while(Info.len < Lines.len)
					{
						Info+= " ";
					}
					Message= Info;


					Info="|Team Kills: ";
					Info+=tl->item->TKNum;
					while(Info.len < Lines.len)
					{
						Info+= " ";
					}
					Message+=Info;

					Info= "|Time Left: ";
					Info+=tl->item->Time/60;
					Info+= " m ";
					Info+=tl->item->Time%60;
					Info+= " s";
					
					while(Info.len < Lines.len)
					{
						Info+=" ";
					}
					Info+="|";
					Message+=Info;

					sendPrivate(p,Message);

					tl=tl->next;
				}
				if(Message.len <= 0)
				{sendPrivate(p, "|              No Team Killers On List Currently!              |");}
				sendPrivate(p,"|" +Lines+Lines+Lines);
			}
			else if(c->check("deletetker"))
			{
				String PlayerName= c->final;
				String Message;

				if(!PlayerName.IsEmpty())
				{
					TkStats* Tker= FindTker(PlayerName);
					if(Tker != NULL)
					{
						TkerList.kill(Tker);
						Message=PlayerName;
						Message+=" Deleted Successfully!";
					}
					else
					{
						Message= "That name was not found on the Tker list!";
					}
				}
				else
				{
					Message="You must specify a player\'s name. Format- !deletetker <PlayerName>";
				}
				sendPrivate(p,Message);

			}
			else if(c->check("killtkmods"))
			{
				String TkMods= c->final; //get final portion of string

				if(TkMods.IsEmpty())
				{
					TkMods= "The bot currently "; 
					if(BanMods)
					{TkMods+= "IS";}
					else
					{TkMods+= "IS NOT";}
					TkMods+= " banning bot-mods that exceed the Tklimit";
				}
				else
				{
					if(TkMods == "yes") //if the command was on
					{
						//then enable the bot
						if(BanMods)
						{TkMods= "The bot is already banning mods that exceed the Tklimit";}
						else
						{
							BanMods =true;
							TkMods= "Complete: Mods that team kill will be banned along with players that exceed the Tklimit";
						}
					}
					else //if the command was off
					{
						if(TkMods == "no")//then disable the bot
						{
							if(BanMods)
							{	
								BanMods=false;
								TkMods= "Complete: Mods will ONLY be *warn(ed) if they exceed the Tklimit";
							}
							else
							{TkMods= "The bot is already ONLY *warn(ing) mods that exceed the Tklimit";}
						}
						else 
						{TkMods= "Invalid command for !killtkmods , use YES or No. Ex- !killtkmods no";}
					}
				}
				sendPrivate(p,TkMods); 
			}
			else if(c->check("warn"))
			{
				String Warning= c->final; //get final portion of string

				if(Warning.IsEmpty()) //if its empty
				{
					Warning= "Tk Warning Message Status: "; //then report the current tk status
					if(Warn)
					{Warning+= "ON";}
					else
					{Warning+= "OFF";}		
				}
				else //if the string has a command in it
				{
					if(Warning == "on") //if the command was on
					{
						//then enable the bot
						if(Warn)
						{Warning= "Tk Warning Message Is Already Enabled";}
						else
						{
							Warn =true;
							Warning= "Tk Warning Message Turned ON Successfully";
						}
					}
					else //if the command was off
					{
						if(Warning == "off")//then disable the bot
						{
							if(Warn)
							{	
								Warn=false;
								Warning= "Tk Warning Message Turned OFF Successfully";
							}
							else
							{Warning= "Tk Warning Message Is Already Disabled";}
						}
						else //if it wasnt a On or OFF command, then it was invalid
						{Warning= "Invalid command for !warn , use ON or OFF. Ex- !warn on";}
					}
				}
				sendPrivate(p,Warning);
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if(c->check("tkstatus"))
			{
				String limits= c->final; //get final portion of string

				if(limits.IsEmpty()) //if its empty
				{
					limits= "Tk Limits Status: "; //then report the current tk status
					if(Enabled)
					{limits+= "ON";}
					else
					{limits+= "OFF";}		
				}
				else //if the string has a command in it
				{
					if(limits == "on") //if the command was on
					{
						//then enable the bot
						if(Enabled)
						{limits= "Tk Limits Are Already Enabled";}
						else
						{
							Enabled =true;
							limits= "Tk Limits Turned ON Successfully";
						}
					}
					else //if the command was off
					{
						if(limits == "off")//then disable the bot
						{
							if(Enabled)
							{	
								Enabled=false;
								RequestList.clear();
								TkerList.clear();
								
								limits= "Tk Limits Turned OFF Successfully";
							}
							else
							{limits= "Tk Limits Are Already Disabled";}
						}
						else //if it wasnt a On or OFF command, then it was invalid
						{limits= "Invalid command for !tkstatus , use ON or OFF. Ex- !tkstatus on";}
					}
				}
				sendPrivate(p,limits);
			}
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
			if(Enabled)
			{
				if(c->check("tker"))
				{
					String PlayerName= c->final;
					String Message;

					Requester *theReq=FindReq(p->name);
					if(theReq == NULL)
					{
						if(!PlayerName.IsEmpty())
						{
							if((PlayerName != p->name) && (PlayerName != me->name))
							{
								TkStats* Tker= FindTker(PlayerName);
								if(Tker == NULL)
								{
									if(PlayerExists(PlayerName))
									{
										if((p->access < OP_Moderator) && (RequestTime > 0))
										{
											NewRequester(p->name);
										}
		
										Tker= new TkStats;
										Tker->Name=PlayerName;
										Tker->Time=TkTime*60;
										Tker->TKNum=0;
										TkerList.append(Tker);
										Message=PlayerName;
										Message+= " is being watched for team kills! Current Limits: ";
										Message+=MaxTks;
										Message+=" team kills allowed in ";
										Message+=TkTime;
										Message+=" minutes.";
									}
									else
									{
										Message= "Player \"";
										Message+= PlayerName;
										Message+= "\" is not in this arena. Format- !tker <PlayerName>";
									}	
								}
								else
								{	
									Message= "Select Another Person: ";
									Message+= PlayerName;
									Message+= " is already being watched for team kills.";
									sendPrivate(p,Message);

									Message="Player\'s Stats- Team Kills: ";
									Message+=Tker->TKNum;
									Message+= " // Time Left: ";
									Message+=Tker->Time/60;
									Message+= " m ";
									Message+=Tker->Time%60;
									Message+= " s";
								}	
							}
							else
							{
								Message= "You must !tker another person, NOT yourself or Me!";
							}
						}	
						else
						{
							Message="You must specify a player\'s name. Format- !tker <PlayerName>";
						}
					}
					else
					{
						Message="You may only make one !tker request every ";
						Message+=RequestTime;
						Message+=" minutes! Time Left:";
						Message+= (RequestTime*60 - ((GetTickCount()-theReq->Time)/1000))/60;
						Message+= "m ";
						Message+= (RequestTime*60 - ((GetTickCount()-theReq->Time)/1000))%60;
						Message+= "s";
					}
					sendPrivate(p,Message);
				}
			}
			if (c->check("about") || c->check("version"))
			{
				sendPrivate(p, "Team Killing Behavior v2 by 50% Packetloss (FiftyPacketloss@socal.rr.com)");
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
